package kc.mega.aim;

import kc.mega.learning.KNNHitRangeModel;
import kc.mega.learning.Model;

public class AimModels {
  public static Model getMainAimModel() {
    return new KNNHitRangeModel.Builder("Main")
        .features(new String[] {"virtuality", "bft", "accel", "vel", "advDir", "orbitalWallAhead", "orbitalWallReverse", "maeWallAhead", "maeWallReverse", "stickWallAhead", "stickWallReverse", "shotsFired"}).params(new double[][] {
          {0.6019, 0.5186, 0.6299},
          {3.7152, 0.1787, 0.4814},
          {7.2600, 0.0102, 0.1645},
          {1.9078, 0.0073, 0.2391},
          {0.8149, 1.0343, 1.5810},
          {1.5990, 0.0056, 0.4755},
          {0.4110, 0.1545, 0.8614},
          {2.2743, 0.2642, 1.2680},
          {1.1372, 0.0322, 1.4072},
          {1.2503, 0.2814, 1.3790},
          {0.6163, 0.1488, 0.3433},
          {0.5392, 0.0098, 0.1828}})
        .distanceScale(-0.7)
        .neighborhoodSizeDivider(5.0)
        .maxNeighbors(200)
        .maxNeighborsFast(100)
        .maxTreeSize(50000).build();
  }

  public static Model getAntiSurferAimModel() {
    return new KNNHitRangeModel.Builder("AntiSurfer")
        .features(new String[] {"virtuality", "bft", "accel", "vel", "dirChangeTimer", "decelTimer", "orbitalWallAhead", "orbitalWallReverse", "maeWallAhead", "maeWallReverse", "stickWallAhead", "stickWallReverse", "didHit", "didCollide"})
        .params(new double[][] {
          {0.7968, 0.2586, 0.5213},
          {2.7854, 0.0518, 2.3925},
          {6.0295, 0.0928, 0.1034},
          {1.4140, 0.2345, 0.4337},
          {0.6622, 0.0181, 0.3774},
          {1.1818, 0.0241, 0.2147},
          {0.9476, 0.0149, 2.0508},
          {0.6203, 0.0963, 1.1435},
          {2.1631, 0.0032, 1.0241},
          {1.3246, 0.3169, 1.3785},
          {0.7411, 0.0595, 2.1006},
          {1.0227, 0.4483, 1.5329},
          {1.8033, 0.2450, 0.7586},
          {0.8578, 0.9126, 1.9106}})
        .distanceScale(-0.72)
        .neighborhoodSizeDivider(5.0)
        .maxNeighbors(100)
        .maxNeighborsFast(50)
        .maxTreeSize(50000).build();
  }
}
