package kc.mega.aim;

import kc.mega.game.BotState;
import kc.mega.utils.KUtils;
import kc.mega.wave.Bullet;
import kc.mega.wave.WaveWithFeatures;

import java.util.List;

public class AimWave extends WaveWithFeatures {
  public final Bullet bullet;
  public final List<Double> aimAngles;

  public static class Builder extends WaveWithFeatures.Builder {
    private double gunHeading;
    private List<Double> aimAngles;
    public Builder gunHeading(double val) {gunHeading = val; return this;}
    public Builder aimAngles(List<Double> val) {aimAngles = val; return this;}
    @Override
    public AimWave build() {return new AimWave(this);}
  }

  private AimWave(Builder builder) {
    super(builder);
    bullet = hasBullet ? new Bullet(source, builder.gunHeading, speed, fireTime) : null;
    aimAngles = builder.aimAngles;
  }

  public void updateModelHits(List<Integer> modelHits) {
    for (int i = 0; i < modelHits.size(); i++) {
      if (aggHitOffsetRange[0] < 100 && KUtils.inBounds(
          getGF(aimAngles.get(i) - absoluteBearing), hitGFRange())) {
        modelHits.set(i, modelHits.get(i) + 1);
      }
    }
  }

  @Override
  public void paint(BotState enemyState, Foam foam) {
    /*if (doPaint && hasBullet) {
      for (double aimAngle : aimAngles) {
        Painter.THIS_TICK.addCircle(aggHitOffsetRange[0] < 100 && KUtils.inBounds(
            getGF(aimAngle - absoluteBearing), hitGFRange()) ? Color.green : Color.yellow,
                Geom.projectMotion(source, aimAngle, radius), 3);
      }
    }*/
  }
}
