package kc.mega.learning;

import kc.mega.wave.WaveWithFeatures;

import java.util.List;

import ags.utils.KdTree.Entry;

public class KNNHitModel extends KNNModel<Double> {
  public static class Builder extends KNNModel.Builder<Double> {
    public Builder(String name) {
      super(name);
    }

    @Override
    public KNNHitModel build() {
      return new KNNHitModel(this);
    }
  }

  private  KNNHitModel(Builder builder) {
    super(builder);
  }

  @Override
  public void train(WaveWithFeatures w) {
    tree.addPoint(embed(w), w.hitGF());
  }

  @Override
  public double[] getDangers(WaveWithFeatures w) {
    List<Entry<Double>> neighbors = tree.nearestNeighbor(embed(w), getNumNeighbors(), false);

    double[] dangers = new double[bins.nBins];
    if (neighbors.size() == 0) {
      return dangers;
    }

    double[] weights = getWeights(neighbors);
    for (int i = 0; i < neighbors.size(); i++) {
      dangers[bins.hitBin(neighbors.get(i).value)] += weights[i];
    }
    return dangers;
  }
}
